diff -crBPN --exclude=htaccess-dist --exclude=wp-config.php --exclude=wordpress.sql --exclude=wp-cache-config.php --exclude=wp-config.php --exclude=wordpress.sql --exclude=.htaccess-dist --exclude=wp-cache-config.php --exclude=1.html --exclude=2.html --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.7.pl /home/packages/code/qi/SOURCES/wordpress-3.6.1/wp-admin/includes/class-wp-filesystem-base.php /home/packages/code/qi/SOURCES/wordpress-3.7/wp-admin/includes/class-wp-filesystem-base.php
*** /home/packages/code/qi/SOURCES/wordpress-3.6.1/wp-admin/includes/class-wp-filesystem-base.php	2013-01-27 19:55:39.000000000 -0600
--- /home/packages/code/qi/SOURCES/wordpress-3.7/wp-admin/includes/class-wp-filesystem-base.php	2013-09-21 23:44:10.000000000 -0500
***************
*** 1,6 ****
  <?php
  /**
!  * Base WordPress Filesystem.
   *
   * @package WordPress
   * @subpackage Filesystem
--- 1,6 ----
  <?php
  /**
!  * Base WordPress Filesystem
   *
   * @package WordPress
   * @subpackage Filesystem
***************
*** 9,22 ****
  /**
   * Base WordPress Filesystem class for which Filesystem implementations extend
   *
!  * @since 2.5
   */
  class WP_Filesystem_Base {
  	/**
  	 * Whether to display debug data for the connection.
  	 *
- 	 * @since 2.5
  	 * @access public
  	 * @var bool
  	 */
  	var $verbose = false;
--- 9,22 ----
  /**
   * Base WordPress Filesystem class for which Filesystem implementations extend
   *
!  * @since 2.5.0
   */
  class WP_Filesystem_Base {
  	/**
  	 * Whether to display debug data for the connection.
  	 *
  	 * @access public
+ 	 * @since 2.5.0
  	 * @var bool
  	 */
  	var $verbose = false;
***************
*** 23,30 ****
  	/**
  	 * Cached list of local filepaths to mapped remote filepaths.
  	 *
- 	 * @since 2.7
  	 * @access private
  	 * @var array
  	 */
  	var $cache = array();
--- 24,31 ----
  	/**
  	 * Cached list of local filepaths to mapped remote filepaths.
  	 *
  	 * @access private
+ 	 * @since 2.7.0
  	 * @var array
  	 */
  	var $cache = array();
***************
*** 32,53 ****
  	/**
  	 * The Access method of the current connection, Set automatically.
  	 *
- 	 * @since 2.5
  	 * @access public
  	 * @var string
  	 */
  	var $method = '';
  
  	/**
! 	 * Returns the path on the remote filesystem of ABSPATH
  	 *
- 	 * @since 2.7
  	 * @access public
  	 * @return string The location of the remote path.
  	 */
  	function abspath() {
  		$folder = $this->find_folder(ABSPATH);
! 		//Perhaps the FTP folder is rooted at the WordPress install, Check for wp-includes folder in root, Could have some false positives, but rare.
  		if ( ! $folder && $this->is_dir('/wp-includes') )
  			$folder = '/';
  		return $folder;
--- 33,60 ----
  	/**
  	 * The Access method of the current connection, Set automatically.
  	 *
  	 * @access public
+ 	 * @since 2.5.0
  	 * @var string
  	 */
  	var $method = '';
  
  	/**
! 	 * Constructor (empty).
! 	 */
! 	function __construct() {}
! 
! 	/**
! 	 * Return the path on the remote filesystem of ABSPATH.
  	 *
  	 * @access public
+ 	 * @since 2.7.0
+ 	 *
  	 * @return string The location of the remote path.
  	 */
  	function abspath() {
  		$folder = $this->find_folder(ABSPATH);
! 		// Perhaps the FTP folder is rooted at the WordPress install, Check for wp-includes folder in root, Could have some false positives, but rare.
  		if ( ! $folder && $this->is_dir('/wp-includes') )
  			$folder = '/';
  		return $folder;
***************
*** 52,62 ****
  			$folder = '/';
  		return $folder;
  	}
  	/**
! 	 * Returns the path on the remote filesystem of WP_CONTENT_DIR
  	 *
- 	 * @since 2.7
  	 * @access public
  	 * @return string The location of the remote path.
  	 */
  	function wp_content_dir() {
--- 59,71 ----
  			$folder = '/';
  		return $folder;
  	}
+ 
  	/**
! 	 * Return the path on the remote filesystem of WP_CONTENT_DIR.
  	 *
  	 * @access public
+ 	 * @since 2.7.0
+ 	 *
  	 * @return string The location of the remote path.
  	 */
  	function wp_content_dir() {
***************
*** 62,72 ****
  	function wp_content_dir() {
  		return $this->find_folder(WP_CONTENT_DIR);
  	}
  	/**
! 	 * Returns the path on the remote filesystem of WP_PLUGIN_DIR
  	 *
- 	 * @since 2.7
  	 * @access public
  	 *
  	 * @return string The location of the remote path.
  	 */
--- 71,82 ----
  	function wp_content_dir() {
  		return $this->find_folder(WP_CONTENT_DIR);
  	}
+ 
  	/**
! 	 * Return the path on the remote filesystem of WP_PLUGIN_DIR.
  	 *
  	 * @access public
+ 	 * @since 2.7.0
  	 *
  	 * @return string The location of the remote path.
  	 */
***************
*** 73,94 ****
  	function wp_plugins_dir() {
  		return $this->find_folder(WP_PLUGIN_DIR);
  	}
  	/**
! 	 * Returns the path on the remote filesystem of the Themes Directory
  	 *
- 	 * @since 2.7
  	 * @access public
  	 *
  	 * @return string The location of the remote path.
  	 */
! 	function wp_themes_dir() {
! 		return $this->wp_content_dir() . 'themes/';
  	}
  	/**
! 	 * Returns the path on the remote filesystem of WP_LANG_DIR
  	 *
- 	 * @since 3.2.0
  	 * @access public
  	 *
  	 * @return string The location of the remote path.
  	 */
--- 83,113 ----
  	function wp_plugins_dir() {
  		return $this->find_folder(WP_PLUGIN_DIR);
  	}
+ 
  	/**
! 	 * Return the path on the remote filesystem of the Themes Directory.
  	 *
  	 * @access public
+ 	 * @since 2.7.0
  	 *
+ 	 * @param string $theme The Theme stylesheet or template for the directory.
  	 * @return string The location of the remote path.
  	 */
! 	function wp_themes_dir( $theme = false ) {
! 		$theme_root = get_theme_root( $theme );
! 
! 		// Account for relative theme roots
! 		if ( '/themes' == $theme_root || ! is_dir( $theme_root ) )
! 			$theme_root = WP_CONTENT_DIR . $theme_root;
! 
! 		return $this->find_folder( $theme_root );
  	}
+ 
  	/**
! 	 * Return the path on the remote filesystem of WP_LANG_DIR.
  	 *
  	 * @access public
+ 	 * @since 3.2.0
  	 *
  	 * @return string The location of the remote path.
  	 */
***************
*** 97,115 ****
  	}
  
  	/**
! 	 * Locates a folder on the remote filesystem.
! 	 *
! 	 * Deprecated; use WP_Filesystem::abspath() or WP_Filesystem::wp_*_dir() methods instead.
  	 *
- 	 * @since 2.5
- 	 * @deprecated 2.7
  	 * @access public
! 	 *
! 	 * @param string $base The folder to start searching from
! 	 * @param bool $echo True to display debug information
  	 * @return string The location of the remote path.
  	 */
! 	function find_base_dir($base = '.', $echo = false) {
  		_deprecated_function(__FUNCTION__, '2.7', 'WP_Filesystem::abspath() or WP_Filesystem::wp_*_dir()' );
  		$this->verbose = $echo;
  		return $this->abspath();
--- 116,138 ----
  	}
  
  	/**
! 	 * Locate a folder on the remote filesystem.
  	 *
  	 * @access public
! 	 * @since 2.5.0
! 	 * @deprecated 2.7.0 use WP_Filesystem::abspath() or WP_Filesystem::wp_*_dir() instead.
! 	 * @see WP_Filesystem::abspath()
! 	 * @see WP_Filesystem::wp_content_dir()
! 	 * @see WP_Filesystem::wp_plugins_dir()
! 	 * @see WP_Filesystem::wp_themes_dir()
! 	 * @see WP_Filesystem::wp_lang_dir()
! 	 *
! 	 * @param string $base The folder to start searching from.
! 	 * @param bool   $echo True to display debug information.
! 	 *                     Default false.
  	 * @return string The location of the remote path.
  	 */
! 	function find_base_dir( $base = '.', $echo = false ) {
  		_deprecated_function(__FUNCTION__, '2.7', 'WP_Filesystem::abspath() or WP_Filesystem::wp_*_dir()' );
  		$this->verbose = $echo;
  		return $this->abspath();
***************
*** 114,169 ****
  		$this->verbose = $echo;
  		return $this->abspath();
  	}
  	/**
! 	 * Locates a folder on the remote filesystem.
! 	 *
! 	 * Deprecated; use WP_Filesystem::abspath() or WP_Filesystem::wp_*_dir() methods instead.
  	 *
- 	 * @since 2.5
- 	 * @deprecated 2.7
  	 * @access public
  	 *
! 	 * @param string $base The folder to start searching from
! 	 * @param bool $echo True to display debug information
  	 * @return string The location of the remote path.
  	 */
! 	function get_base_dir($base = '.', $echo = false) {
  		_deprecated_function(__FUNCTION__, '2.7', 'WP_Filesystem::abspath() or WP_Filesystem::wp_*_dir()' );
  		$this->verbose = $echo;
  		return $this->abspath();
  	}
  
  	/**
! 	 * Locates a folder on the remote filesystem.
  	 *
! 	 * Assumes that on Windows systems, Stripping off the Drive letter is OK
! 	 * Sanitizes \\ to / in windows filepaths.
  	 *
- 	 * @since 2.7
  	 * @access public
  	 *
! 	 * @param string $folder the folder to locate
  	 * @return string The location of the remote path.
  	 */
! 	function find_folder($folder) {
  
! 		if ( strpos($this->method, 'ftp') !== false ) {
! 			$constant_overrides = array( 'FTP_BASE' => ABSPATH, 'FTP_CONTENT_DIR' => WP_CONTENT_DIR, 'FTP_PLUGIN_DIR' => WP_PLUGIN_DIR, 'FTP_LANG_DIR' => WP_LANG_DIR );
! 			foreach ( $constant_overrides as $constant => $dir )
! 				if ( defined($constant) && $folder === $dir )
! 					return trailingslashit(constant($constant));
  		} elseif ( 'direct' == $this->method ) {
! 			$folder = str_replace('\\', '/', $folder); //Windows path sanitisation
  			return trailingslashit($folder);
  		}
  
! 		$folder = preg_replace('|^([a-z]{1}):|i', '', $folder); //Strip out windows drive letter if it's there.
! 		$folder = str_replace('\\', '/', $folder); //Windows path sanitisation
  
  		if ( isset($this->cache[ $folder ] ) )
  			return $this->cache[ $folder ];
  
! 		if ( $this->exists($folder) ) { //Folder exists at that absolute path.
  			$folder = trailingslashit($folder);
  			$this->cache[ $folder ] = $folder;
  			return $folder;
--- 137,224 ----
  		$this->verbose = $echo;
  		return $this->abspath();
  	}
+ 
  	/**
! 	 * Locate a folder on the remote filesystem.
  	 *
  	 * @access public
+ 	 * @since 2.5.0
+ 	 * @deprecated 2.7.0 use WP_Filesystem::abspath() or WP_Filesystem::wp_*_dir() methods instead.
+ 	 * @see WP_Filesystem::abspath()
+ 	 * @see WP_Filesystem::wp_content_dir()
+ 	 * @see WP_Filesystem::wp_plugins_dir()
+ 	 * @see WP_Filesystem::wp_themes_dir()
+ 	 * @see WP_Filesystem::wp_lang_dir()
  	 *
! 	 * @param string $base The folder to start searching from.
! 	 * @param bool   $echo True to display debug information.
  	 * @return string The location of the remote path.
  	 */
! 	function get_base_dir( $base = '.', $echo = false ) {
  		_deprecated_function(__FUNCTION__, '2.7', 'WP_Filesystem::abspath() or WP_Filesystem::wp_*_dir()' );
  		$this->verbose = $echo;
  		return $this->abspath();
  	}
  
  	/**
! 	 * Locate a folder on the remote filesystem.
  	 *
! 	 * Assumes that on Windows systems, Stripping off the Drive
! 	 * letter is OK Sanitizes \\ to / in windows filepaths.
  	 *
  	 * @access public
+ 	 * @since 2.7.0
  	 *
! 	 * @param string $folder the folder to locate.
  	 * @return string The location of the remote path.
  	 */
! 	function find_folder( $folder ) {
  
! 		if ( isset( $this->cache[ $folder ] ) )
! 			return $this->cache[ $folder ];
! 
! 		if ( stripos($this->method, 'ftp') !== false ) {
! 			$constant_overrides = array(
! 				'FTP_BASE' => ABSPATH,
! 				'FTP_CONTENT_DIR' => WP_CONTENT_DIR,
! 				'FTP_PLUGIN_DIR' => WP_PLUGIN_DIR,
! 				'FTP_LANG_DIR' => WP_LANG_DIR
! 			);
! 
! 			// Direct matches ( folder = CONSTANT/ )
! 			foreach ( $constant_overrides as $constant => $dir ) {
! 				if ( ! defined( $constant ) )
! 					continue;
! 				if ( $folder === $dir )
! 					return trailingslashit( constant( $constant ) );
! 			}
! 
! 			// Prefix Matches ( folder = CONSTANT/subdir )
! 			foreach ( $constant_overrides as $constant => $dir ) {
! 				if ( ! defined( $constant ) )
! 					continue;
! 				if ( 0 === stripos( $folder, $dir ) ) { // $folder starts with $dir
! 					$potential_folder = preg_replace( '#^' . preg_quote( $dir, '#' ) . '/#i', trailingslashit( constant( $constant ) ), $folder );
! 					$potential_folder = trailingslashit( $potential_folder );
! 
! 					if ( $this->is_dir( $potential_folder ) ) {
! 						$this->cache[ $folder ] = $potential_folder;
! 						return $potential_folder;
! 					}
! 				}
! 			}
  		} elseif ( 'direct' == $this->method ) {
! 			$folder = str_replace('\\', '/', $folder); // Windows path sanitisation
  			return trailingslashit($folder);
  		}
  
! 		$folder = preg_replace('|^([a-z]{1}):|i', '', $folder); // Strip out windows drive letter if it's there.
! 		$folder = str_replace('\\', '/', $folder); // Windows path sanitisation
  
  		if ( isset($this->cache[ $folder ] ) )
  			return $this->cache[ $folder ];
  
! 		if ( $this->exists($folder) ) { // Folder exists at that absolute path.
  			$folder = trailingslashit($folder);
  			$this->cache[ $folder ] = $folder;
  			return $folder;
***************
*** 174,216 ****
  	}
  
  	/**
! 	 * Locates a folder on the remote filesystem.
  	 *
! 	 * Expects Windows sanitized path
  	 *
- 	 * @since 2.7
  	 * @access private
  	 *
! 	 * @param string $folder the folder to locate
! 	 * @param string $base the folder to start searching from
! 	 * @param bool $loop if the function has recursed, Internal use only
  	 * @return string The location of the remote path.
  	 */
! 	function search_for_folder($folder, $base = '.', $loop = false ) {
  		if ( empty( $base ) || '.' == $base )
  			$base = trailingslashit($this->cwd());
  
  		$folder = untrailingslashit($folder);
  
  		$folder_parts = explode('/', $folder);
! 		$last_index = array_pop( array_keys( $folder_parts ) );
  		$last_path = $folder_parts[ $last_index ];
  
  		$files = $this->dirlist( $base );
  
  		foreach ( $folder_parts as $index => $key ) {
  			if ( $index == $last_index )
! 				continue; //We want this to be caught by the next code block.
  
! 			//Working from /home/ to /user/ to /wordpress/ see if that file exists within the current folder,
  			// If it's found, change into it and follow through looking for it.
  			// If it cant find WordPress down that route, it'll continue onto the next folder level, and see if that matches, and so on.
  			// If it reaches the end, and still cant find it, it'll return false for the entire function.
  			if ( isset($files[ $key ]) ){
! 				//Lets try that folder:
  				$newdir = trailingslashit(path_join($base, $key));
  				if ( $this->verbose )
! 					printf( __('Changing to %s') . '<br/>', $newdir );
  				// only search for the remaining path tokens in the directory, not the full path again
  				$newfolder = implode( '/', array_slice( $folder_parts, $index + 1 ) );
  				if ( $ret = $this->search_for_folder( $newfolder, $newdir, $loop) )
--- 229,275 ----
  	}
  
  	/**
! 	 * Locate a folder on the remote filesystem.
  	 *
! 	 * Expects Windows sanitized path.
  	 *
  	 * @access private
+ 	 * @since 2.7.0
  	 *
! 	 * @param string $folder The folder to locate.
! 	 * @param string $base   The folder to start searching from.
! 	 * @param bool   $loop   If the function has recursed, Internal use only.
  	 * @return string The location of the remote path.
  	 */
! 	function search_for_folder( $folder, $base = '.', $loop = false ) {
  		if ( empty( $base ) || '.' == $base )
  			$base = trailingslashit($this->cwd());
  
  		$folder = untrailingslashit($folder);
  
+ 		if ( $this->verbose )
+ 			printf( "\n" . __('Looking for %1$s in %2$s') . "<br/>\n", $folder, $base );
+ 
  		$folder_parts = explode('/', $folder);
! 		$folder_part_keys = array_keys( $folder_parts );
! 		$last_index = array_pop( $folder_part_keys );
  		$last_path = $folder_parts[ $last_index ];
  
  		$files = $this->dirlist( $base );
  
  		foreach ( $folder_parts as $index => $key ) {
  			if ( $index == $last_index )
! 				continue; // We want this to be caught by the next code block.
  
! 			// Working from /home/ to /user/ to /wordpress/ see if that file exists within the current folder,
  			// If it's found, change into it and follow through looking for it.
  			// If it cant find WordPress down that route, it'll continue onto the next folder level, and see if that matches, and so on.
  			// If it reaches the end, and still cant find it, it'll return false for the entire function.
  			if ( isset($files[ $key ]) ){
! 				// Lets try that folder:
  				$newdir = trailingslashit(path_join($base, $key));
  				if ( $this->verbose )
! 					printf( "\n" . __('Changing to %s') . "<br/>\n", $newdir );
  				// only search for the remaining path tokens in the directory, not the full path again
  				$newfolder = implode( '/', array_slice( $folder_parts, $index + 1 ) );
  				if ( $ret = $this->search_for_folder( $newfolder, $newdir, $loop) )
***************
*** 218,249 ****
  			}
  		}
  
! 		//Only check this as a last resort, to prevent locating the incorrect install. All above procedures will fail quickly if this is the right branch to take.
  		if (isset( $files[ $last_path ] ) ) {
  			if ( $this->verbose )
! 				printf( __('Found %s') . '<br/>',  $base . $last_path );
  			return trailingslashit($base . $last_path);
  		}
! 		if ( $loop )
! 			return false; //Prevent this function from looping again.
! 		//As an extra last resort, Change back to / if the folder wasn't found. This comes into effect when the CWD is /home/user/ but WP is at /var/www/.... mainly dedicated setups.
! 		return $this->search_for_folder($folder, '/', true);
  
  	}
  
  	/**
! 	 * Returns the *nix style file permissions for a file
  	 *
! 	 * From the PHP documentation page for fileperms()
  	 *
  	 * @link http://docs.php.net/fileperms
! 	 * @since 2.5
  	 * @access public
  	 *
! 	 * @param string $file string filename
! 	 * @return string *nix style representation of permissions
  	 */
! 	function gethchmod($file){
  		$perms = $this->getchmod($file);
  		if (($perms & 0xC000) == 0xC000) // Socket
  			$info = 's';
--- 277,314 ----
  			}
  		}
  
! 		// Only check this as a last resort, to prevent locating the incorrect install. All above procedures will fail quickly if this is the right branch to take.
  		if (isset( $files[ $last_path ] ) ) {
  			if ( $this->verbose )
! 				printf( "\n" . __('Found %s') . "<br/>\n",  $base . $last_path );
  			return trailingslashit($base . $last_path);
  		}
! 
! 		// Prevent this function from looping again.
! 		// No need to proceed if we've just searched in /
! 		if ( $loop || '/' == $base )
! 			return false;
! 
! 		// As an extra last resort, Change back to / if the folder wasn't found.
! 		// This comes into effect when the CWD is /home/user/ but WP is at /var/www/....
! 		return $this->search_for_folder( $folder, '/', true );
  
  	}
  
  	/**
! 	 * Return the *nix-style file permissions for a file.
  	 *
! 	 * From the PHP documentation page for fileperms().
  	 *
  	 * @link http://docs.php.net/fileperms
! 	 *
  	 * @access public
+ 	 * @since 2.5.0
  	 *
! 	 * @param string $file String filename.
! 	 * @return string The *nix-style representation of permissions.
  	 */
! 	function gethchmod( $file ){
  		$perms = $this->getchmod($file);
  		if (($perms & 0xC000) == 0xC000) // Socket
  			$info = 's';
***************
*** 286,304 ****
  	}
  
  	/**
! 	 * Converts *nix style file permissions to a octal number.
  	 *
  	 * Converts '-rw-r--r--' to 0644
  	 * From "info at rvgate dot nl"'s comment on the PHP documentation for chmod()
   	 *
  	 * @link http://docs.php.net/manual/en/function.chmod.php#49614
! 	 * @since 2.5
  	 * @access public
  	 *
! 	 * @param string $mode string *nix style file permission
  	 * @return int octal representation
  	 */
! 	function getnumchmodfromh($mode) {
  		$realmode = '';
  		$legal =  array('', 'w', 'r', 'x', '-');
  		$attarray = preg_split('//', $mode);
--- 351,370 ----
  	}
  
  	/**
! 	 * Convert *nix-style file permissions to a octal number.
  	 *
  	 * Converts '-rw-r--r--' to 0644
  	 * From "info at rvgate dot nl"'s comment on the PHP documentation for chmod()
   	 *
  	 * @link http://docs.php.net/manual/en/function.chmod.php#49614
! 	 *
  	 * @access public
+ 	 * @since 2.5.0
  	 *
! 	 * @param string $mode string The *nix-style file permission.
  	 * @return int octal representation
  	 */
! 	function getnumchmodfromh( $mode ) {
  		$realmode = '';
  		$legal =  array('', 'w', 'r', 'x', '-');
  		$attarray = preg_split('//', $mode);
***************
*** 319,333 ****
  	}
  
  	/**
! 	 * Determines if the string provided contains binary characters.
  	 *
- 	 * @since 2.7
  	 * @access private
  	 *
! 	 * @param string $text String to test against
! 	 * @return bool true if string is binary, false otherwise
  	 */
  	function is_binary( $text ) {
! 		return (bool) preg_match('|[^\x20-\x7E]|', $text); //chr(32)..chr(127)
  	}
! }
--- 385,763 ----
  	}
  
  	/**
! 	 * Determine if the string provided contains binary characters.
  	 *
  	 * @access private
+ 	 * @since 2.7.0
  	 *
! 	 * @param string $text String to test against.
! 	 * @return bool true if string is binary, false otherwise.
  	 */
  	function is_binary( $text ) {
! 		return (bool) preg_match( '|[^\x20-\x7E]|', $text ); // chr(32)..chr(127)
! 	}
! 
! 	/**
! 	 * Change the ownership of a file / folder.
! 	 *
! 	 * Default behavior is to do nothing, override this in your subclass, if desired.
! 	 *
! 	 * @since 2.5.0
! 	 *
! 	 * @param string $file      Path to the file.
! 	 * @param mixed  $owner     A user name or number.
! 	 * @param bool   $recursive Optional. If set True changes file owner recursivly. Defaults to False.
! 	 * @return bool Returns true on success or false on failure.
! 	 */
! 	function chown( $file, $owner, $recursive = false ) {
! 		return false;
! 	}
! 
! 	/**
! 	 * Connect filesystem.
! 	 *
! 	 * @since 2.5.0
! 	 *
! 	 * @return bool True on success or false on failure (always true for WP_Filesystem_Direct).
! 	 */
! 	function connect() {
! 		return true;
! 	}
! 
! 	/**
! 	 * Read entire file into a string.
! 	 *
! 	 * @since 2.5.0
! 	 *
! 	 * @param string $file Name of the file to read.
! 	 * @return string|bool Returns the read data or false on failure.
! 	 */
! 	function get_contents( $file ) {
! 		return false;
! 	}
! 
! 	/**
! 	 * Read entire file into an array.
! 	 *
! 	 * @since 2.5.0
! 	 *
! 	 * @param string $file Path to the file.
! 	 * @return array|bool the file contents in an array or false on failure.
! 	 */
! 	function get_contents_array( $file ) {
! 		return false;
! 	}
! 
! 	/**
! 	 * Write a string to a file.
! 	 *
! 	 * @since 2.5.0
! 	 *
! 	 * @param string $file     Remote path to the file where to write the data.
! 	 * @param string $contents The data to write.
! 	 * @param int    $mode     Optional. The file permissions as octal number, usually 0644.
! 	 * @return bool False on failure.
! 	 */
! 	function put_contents( $file, $contents, $mode = false ) {
! 		return false;
! 	}
! 
! 	/**
! 	 * Get the current working directory.
! 	 *
! 	 * @since 2.5.0
! 	 *
! 	 * @return string|bool The current working directory on success, or false on failure.
! 	 */
! 	function cwd() {
! 		return false;
! 	}
! 
! 	/**
! 	 * Change current directory.
! 	 *
! 	 * @since 2.5.0
! 	 *
! 	 * @param string $dir The new current directory.
! 	 * @return bool Returns true on success or false on failure.
! 	 */
! 	function chdir( $dir ) {
! 		return false;
! 	}
! 
! 	/**
! 	 * Change the file group.
! 	 *
! 	 * @since 2.5.0
! 	 *
! 	 * @param string $file      Path to the file.
! 	 * @param mixed  $group     A group name or number.
! 	 * @param bool   $recursive Optional. If set True changes file group recursively. Defaults to False.
! 	 * @return bool Returns true on success or false on failure.
! 	 */
! 	function chgrp( $file, $group, $recursive = false ) {
! 		return false;
! 	}
! 
! 	/**
! 	 * Change filesystem permissions.
! 	 *
! 	 * @since 2.5.0
! 	 *
! 	 * @param string $file      Path to the file.
! 	 * @param int    $mode      Optional. The permissions as octal number, usually 0644 for files, 0755 for dirs.
! 	 * @param bool   $recursive Optional. If set True changes file group recursively. Defaults to False.
! 	 * @return bool Returns true on success or false on failure.
! 	 */
! 	function chmod( $file, $mode = false, $recursive = false ) {
! 		return false;
! 	}
! 
! 	/**
! 	 * Get the file owner.
! 	 *
! 	 * @since 2.5.0
! 	 *
! 	 * @param string $file Path to the file.
! 	 * @return string|bool Username of the user or false on error.
! 	 */
! 	function owner( $file ) {
! 		return false;
! 	}
! 
! 	/**
! 	 * Get the file's group.
! 	 *
! 	 * @since 2.5.0
! 	 *
! 	 * @param string $file Path to the file.
! 	 * @return string|bool The group or false on error.
! 	 */
! 	function group( $file ) {
! 		return false;
! 	}
! 
! 	/**
! 	 * Copy a file.
! 	 *
! 	 * @since 2.5.0
! 	 *
! 	 * @param string $source      Path to the source file.
! 	 * @param string $destination Path to the destination file.
! 	 * @param bool   $overwrite   Optional. Whether to overwrite the destination file if it exists.
! 	 *                            Default false.
! 	 * @param int    $mode        Optional. The permissions as octal number, usually 0644 for files, 0755 for dirs.
! 	 *                            Default false.
! 	 * @return bool True if file copied successfully, False otherwise.
! 	 */
! 	function copy( $source, $destination, $overwrite = false, $mode = false ) {
! 		return false;
! 	}
! 
! 	/**
! 	 * Move a file.
! 	 *
! 	 * @since 2.5.0
! 	 *
! 	 * @param string $source      Path to the source file.
! 	 * @param string $destination Path to the destination file.
! 	 * @param bool   $overwrite   Optional. Whether to overwrite the destination file if it exists.
! 	 *                            Default false.
! 	 * @return bool True if file copied successfully, False otherwise.
! 	 */
! 	function move( $source, $destination, $overwrite = false ) {
! 		return false;
! 	}
! 
! 	/**
! 	 * Delete a file or directory.
! 	 *
! 	 * @since 2.5.0
! 	 *
! 	 * @param string $file      Path to the file.
! 	 * @param bool   $recursive Optional. If set True changes file group recursively. Defaults to False.
! 	 *                          Default false.
! 	 * @param bool   $type      Type of resource. 'f' for file, 'd' for directory.
! 	 *                          Default false.
! 	 * @return bool True if the file or directory was deleted, false on failure.
! 	 */
! 	function delete( $file, $recursive = false, $type = false ) {
! 		return false;
! 	}
! 
! 	/**
! 	 * Check if a file or directory exists.
! 	 *
! 	 * @since 2.5.0
! 	 *
! 	 * @param string $file Path to file/directory.
! 	 * @return bool Whether $file exists or not.
! 	 */
! 	function exists( $file ) {
! 		return false;
! 	}
! 
! 	/**
! 	 * Check if resource is a file.
! 	 *
! 	 * @since 2.5.0
! 	 *
! 	 * @param string $file File path.
! 	 * @return bool Whether $file is a file.
! 	 */
! 	function is_file( $file ) {
! 		return false;
! 	}
! 
! 	/**
! 	 * Check if resource is a directory.
! 	 *
! 	 * @since 2.5.0
! 	 *
! 	 * @param string $path Directory path.
! 	 * @return bool Whether $path is a directory.
! 	 */
! 	function is_dir( $path ) {
! 		return false;
! 	}
! 
! 	/**
! 	 * Check if a file is readable.
! 	 *
! 	 * @since 2.5.0
! 	 *
! 	 * @param string $file Path to file.
! 	 * @return bool Whether $file is readable.
! 	 */
! 	function is_readable( $file ) {
! 		return false;
! 	}
! 
! 	/**
! 	 * Check if a file or directory is writable.
! 	 *
! 	 * @since 2.5.0
! 	 *
! 	 * @param string $path Path to file/directory.
! 	 * @return bool Whether $file is writable.
! 	 */
! 	function is_writable( $file ) {
! 		return false;
! 	}
! 
! 	/**
! 	 * Gets the file's last access time.
! 	 *
! 	 * @since 2.5.0
! 	 *
! 	 * @param string $file Path to file.
! 	 * @return int Unix timestamp representing last access time.
! 	 */
! 	function atime( $file ) {
! 		return false;
! 	}
! 
! 	/**
! 	 * Gets the file modification time.
! 	 *
! 	 * @since 2.5.0
! 	 *
! 	 * @param string $file Path to file.
! 	 * @return int Unix timestamp representing modification time.
! 	 */
! 	function mtime( $file ) {
! 		return false;
! 	}
! 
! 	/**
! 	 * Gets the file size (in bytes).
! 	 *
! 	 * @since 2.5.0
! 	 *
! 	 * @param string $file Path to file.
! 	 * @return int Size of the file in bytes.
! 	 */
! 	function size( $file ) {
! 		return false;
  	}
! 
! 	/**
! 	 * Set the access and modification times of a file.
! 	 *
! 	 * Note: If $file doesn't exist, it will be created.
! 	 *
! 	 * @since 2.5.0
! 	 *
! 	 * @param string $file  Path to file.
! 	 * @param int    $time  Optional. Modified time to set for file.
! 	 *                      Default 0.
! 	 * @param int    $atime Optional. Access time to set for file.
! 	 *                      Default 0.
! 	 * @return bool Whether operation was successful or not.
! 	 */
! 	function touch( $file, $time = 0, $atime = 0 ) {
! 		return false;
! 	}
! 
! 	/**
! 	 * Create a directory.
! 	 *
! 	 * @since 2.5.0
! 	 *
! 	 * @param string $path  Path for new directory.
! 	 * @param mixed  $chmod Optional. The permissions as octal number, (or False to skip chmod)
! 	 *                      Default false.
! 	 * @param mixed  $chown Optional. A user name or number (or False to skip chown)
! 	 *                      Default false.
! 	 * @param mixed  $chgrp Optional. A group name or number (or False to skip chgrp).
! 	 *                      Default false.
! 	 * @return bool False if directory cannot be created, true otherwise.
! 	 */
! 	function mkdir( $path, $chmod = false, $chown = false, $chgrp = false ) {
! 		return false;
! 	}
! 
! 	/**
! 	 * Delete a directory.
! 	 *
! 	 * @since 2.5.0
! 	 *
! 	 * @param string $path      Path to directory.
! 	 * @param bool   $recursive Optional. Whether to recursively remove files/directories.
! 	 *                          Default false.
! 	 * @return bool Whether directory is deleted successfully or not.
! 	 */
! 	function rmdir( $path, $recursive = false ) {
! 		return false;
! 	}
! 
! 	/**
! 	 * Get details for files in a directory or a specific file.
! 	 *
! 	 * @since 2.5.0
! 	 *
! 	 * @param string $path           Path to directory or file.
! 	 * @param bool   $include_hidden Optional. Whether to include details of hidden ("." prefixed) files.
! 	 *                               Default true.
! 	 * @param bool   $recursive      Optional. Whether to recursively include file details in nested directories.
! 	 *                               Default false.
! 	 * @return array|bool {
! 	 *     Array of files. False if unable to list directory contents.
! 	 *
! 	 *     @type string 'name'        Name of the file/directory.
! 	 *     @type string 'perms'       *nix representation of permissions.
! 	 *     @type int    'permsn'      Octal representation of permissions.
! 	 *     @type string 'owner'       Owner name or ID.
! 	 *     @type int    'size'        Size of file in bytes.
! 	 *     @type int    'lastmodunix' Last modified unix timestamp.
! 	 *     @type mixed  'lastmod'     Last modified month (3 letter) and day (without leading 0).
! 	 *     @type int    'time'        Last modified time.
! 	 *     @type string 'type'        Type of resource. 'f' for file, 'd' for directory.
! 	 *     @type mixed  'files'       If a directory and $recursive is true, contains another array of files.
! 	 * }
! 	 */
! 	function dirlist( $path, $include_hidden = true, $recursive = false ) {
! 		return false;
! 	}
! 
! } // WP_Filesystem_Base
